#ifndef __LIBNLDLM_H__
#define __LIBNLDLM_H__

#include <arpa/inet.h>
#include <stdint.h>
#include <errno.h>

#include "nldlm-user.h"

struct nldlmw_ctx;

int nldlmw_dump_lockspaces(struct nldlmw_ctx *ctx,
			   void (*cb)(const struct nldlm_get_ls_rsp *ls));

int nldlmw_dump_members(struct nldlmw_ctx *ctx, const char *lsname,
			void (*cb)(const struct nldlm_get_ls_member_rsp *mb));
int nldlmw_ls_add_member(struct nldlmw_ctx *ctx, const char *lsname,
			 unsigned int nodeid);
int nldlmw_ls_del_member(struct nldlmw_ctx *ctx, const char *lsname,
			 unsigned int nodeid);
int nldlmw_ls_event_done_success(struct nldlmw_ctx *ctx, const char *lsname,
				 unsigned int ls_global_id);
int nldlmw_ls_event_done_failure(struct nldlmw_ctx *ctx, const char *lsname);
int nldlmw_ls_control(struct nldlmw_ctx *ctx, const char *lsname,
		      enum nldlm_ls_ctrl_action action);

int nldlmw_new_node(struct nldlmw_ctx *ctx, unsigned int nodeid,
		    const struct sockaddr_storage *addr);
int nldlmw_dump_nodes(struct nldlmw_ctx *ctx,
		      void (*cb)(const struct nldlm_get_node_rsp *nd));

int nldlmw_set_cluster_name(struct nldlmw_ctx *ctx, const char *cluster_name);
int nldlmw_set_recover_callbacks(struct nldlmw_ctx *ctx, int on);
int nldlmw_set_our_nodeid(struct nldlmw_ctx *ctx, unsigned int nodeid);
int nldlmw_get_config(struct nldlmw_ctx *ctx,
		      void (*cb)(const struct nldlm_get_cfg_rsp *cfg));

int nldlmw_subscribe_events(struct nldlmw_ctx *ctx, const char *group,
			    void (*cb)(__u8 cmd, const struct nldlm_get_ls_rsp *ls, void *data),
			    void *data);
int nldlmw_process(struct nldlmw_ctx *ctx);
int nldlmw_get_fd(const struct nldlmw_ctx *ctx);
int nldlmw_init(struct nldlmw_ctx **ctx);
void nldlmw_exit(struct nldlmw_ctx *c);

#endif /* __LIBNLDLM_H__ */
