// SPDX-License-Identifier: ((GPL-2.0 WITH Linux-syscall-note) OR BSD-3-Clause)
/* Do not edit directly, auto-generated from: */
/*	Documentation/netlink/specs/nldlm.yaml */
/* YNL-GEN user source */

#include <stdlib.h>
#include <string.h>
#include "nldlm-user.h"
#include "ynl.h"
#include <linux/nldlm.h>

#include <linux/genetlink.h>

/* Enums */
static const char * const nldlm_op_strmap[] = {
	[NLDLM_CMD_GET_NODE] = "get-node",
	[NLDLM_CMD_ADD_NODE] = "add-node",
	[NLDLM_CMD_DEL_NODE] = "del-node",
	[NLDLM_CMD_GET_LS] = "get-ls",
	[NLDLM_CMD_GET_LS_MEMBER] = "get-ls-member",
	[NLDLM_CMD_LS_ADD_MEMBER] = "ls-add-member",
	[NLDLM_CMD_LS_DEL_MEMBER] = "ls-del-member",
	[NLDLM_CMD_LS_CTRL] = "ls-ctrl",
	[NLDLM_CMD_NTF_NEW_LS] = "ntf-new-ls",
	[NLDLM_CMD_NTF_RELEASE_LS] = "ntf-release-ls",
	[NLDLM_CMD_LS_EVENT_DONE] = "ls-event-done",
	[NLDLM_CMD_GET_CFG] = "get-cfg",
	[NLDLM_CMD_SET_OUR_NODEID] = "set-our-nodeid",
	[NLDLM_CMD_SET_CLUSTER_NAME] = "set-cluster-name",
	[NLDLM_CMD_SET_PROTOCOL] = "set-protocol",
	[NLDLM_CMD_SET_PORT] = "set-port",
	[NLDLM_CMD_SET_RECOVER_TIMEOUT] = "set-recover-timeout",
	[NLDLM_CMD_SET_INACTIVE_TIMEOUT] = "set-inactive-timeout",
	[NLDLM_CMD_SET_LOG_LEVEL] = "set-log-level",
	[NLDLM_CMD_SET_DEFAULT_MARK] = "set-default-mark",
	[NLDLM_CMD_SET_RECOVER_CALLBACKS] = "set-recover-callbacks",
};

const char *nldlm_op_str(int op)
{
	if (op < 0 || op >= (int)YNL_ARRAY_SIZE(nldlm_op_strmap))
		return NULL;
	return nldlm_op_strmap[op];
}

static const char * const nldlm_protocol_strmap[] = {
	[0] = "TCP",
	[1] = "SCTP",
};

const char *nldlm_protocol_str(enum nldlm_protocol value)
{
	if (value < 0 || value >= (int)YNL_ARRAY_SIZE(nldlm_protocol_strmap))
		return NULL;
	return nldlm_protocol_strmap[value];
}

static const char * const nldlm_log_level_strmap[] = {
	[0] = "NONE",
	[1] = "INFO",
	[2] = "DEBUG",
};

const char *nldlm_log_level_str(enum nldlm_log_level value)
{
	if (value < 0 || value >= (int)YNL_ARRAY_SIZE(nldlm_log_level_strmap))
		return NULL;
	return nldlm_log_level_strmap[value];
}

static const char * const nldlm_ls_ctrl_action_strmap[] = {
	[0] = "STOP",
	[1] = "START",
};

const char *nldlm_ls_ctrl_action_str(enum nldlm_ls_ctrl_action value)
{
	if (value < 0 || value >= (int)YNL_ARRAY_SIZE(nldlm_ls_ctrl_action_strmap))
		return NULL;
	return nldlm_ls_ctrl_action_strmap[value];
}

static const char * const nldlm_ls_event_result_strmap[] = {
	[0] = "SUCCESS",
	[1] = "FAILURE",
};

const char *nldlm_ls_event_result_str(enum nldlm_ls_event_result value)
{
	if (value < 0 || value >= (int)YNL_ARRAY_SIZE(nldlm_ls_event_result_strmap))
		return NULL;
	return nldlm_ls_event_result_strmap[value];
}

/* Policies */
struct ynl_policy_attr nldlm_addr_policy[NLDLM_A_ADDR_MAX + 1] = {
	[NLDLM_A_ADDR_FAMILY] = { .name = "family", .type = YNL_PT_U16, },
	[NLDLM_A_ADDR_ADDR4] = { .name = "addr4", .type = YNL_PT_U32, },
	[NLDLM_A_ADDR_ADDR6] = { .name = "addr6", .type = YNL_PT_BINARY,},
};

struct ynl_policy_nest nldlm_addr_nest = {
	.max_attr = NLDLM_A_ADDR_MAX,
	.table = nldlm_addr_policy,
};

struct ynl_policy_attr nldlm_node_policy[NLDLM_A_NODE_MAX + 1] = {
	[NLDLM_A_NODE_ID] = { .name = "id", .type = YNL_PT_U32, },
	[NLDLM_A_NODE_MARK] = { .name = "mark", .type = YNL_PT_U32, },
	[NLDLM_A_NODE_ADDRS] = { .name = "addrs", .type = YNL_PT_NEST, .nest = &nldlm_addr_nest, },
};

struct ynl_policy_nest nldlm_node_nest = {
	.max_attr = NLDLM_A_NODE_MAX,
	.table = nldlm_node_policy,
};

struct ynl_policy_attr nldlm_ls_policy[NLDLM_A_LS_MAX + 1] = {
	[NLDLM_A_LS_NAME] = { .name = "name", .type = YNL_PT_NUL_STR, },
};

struct ynl_policy_nest nldlm_ls_nest = {
	.max_attr = NLDLM_A_LS_MAX,
	.table = nldlm_ls_policy,
};

struct ynl_policy_attr nldlm_ls_member_policy[NLDLM_A_LS_MEMBER_MAX + 1] = {
	[NLDLM_A_LS_MEMBER_LS_NAME] = { .name = "ls-name", .type = YNL_PT_NUL_STR, },
	[NLDLM_A_LS_MEMBER_NODEID] = { .name = "nodeid", .type = YNL_PT_U32, },
	[NLDLM_A_LS_MEMBER_WEIGHT] = { .name = "weight", .type = YNL_PT_U32, },
};

struct ynl_policy_nest nldlm_ls_member_nest = {
	.max_attr = NLDLM_A_LS_MEMBER_MAX,
	.table = nldlm_ls_member_policy,
};

struct ynl_policy_attr nldlm_ls_ctrl_policy[NLDLM_A_LS_CTRL_MAX + 1] = {
	[NLDLM_A_LS_CTRL_LS_NAME] = { .name = "ls-name", .type = YNL_PT_NUL_STR, },
	[NLDLM_A_LS_CTRL_ACTION] = { .name = "action", .type = YNL_PT_U32, },
};

struct ynl_policy_nest nldlm_ls_ctrl_nest = {
	.max_attr = NLDLM_A_LS_CTRL_MAX,
	.table = nldlm_ls_ctrl_policy,
};

struct ynl_policy_attr nldlm_ls_event_result_policy[NLDLM_A_LS_EVENT_RESULT_MAX + 1] = {
	[NLDLM_A_LS_EVENT_RESULT_LS_NAME] = { .name = "ls-name", .type = YNL_PT_NUL_STR, },
	[NLDLM_A_LS_EVENT_RESULT_LS_GLOBAL_ID] = { .name = "ls-global-id", .type = YNL_PT_U32, },
	[NLDLM_A_LS_EVENT_RESULT_RESULT] = { .name = "result", .type = YNL_PT_U32, },
};

struct ynl_policy_nest nldlm_ls_event_result_nest = {
	.max_attr = NLDLM_A_LS_EVENT_RESULT_MAX,
	.table = nldlm_ls_event_result_policy,
};

struct ynl_policy_attr nldlm_cfg_policy[NLDLM_A_CFG_MAX + 1] = {
	[NLDLM_A_CFG_OUR_NODEID] = { .name = "our-nodeid", .type = YNL_PT_U32, },
	[NLDLM_A_CFG_CLUSTER_NAME] = { .name = "cluster-name", .type = YNL_PT_NUL_STR, },
	[NLDLM_A_CFG_PROTOCOL] = { .name = "protocol", .type = YNL_PT_U32, },
	[NLDLM_A_CFG_PORT] = { .name = "port", .type = YNL_PT_U16, },
	[NLDLM_A_CFG_RECOVER_TIMEOUT] = { .name = "recover-timeout", .type = YNL_PT_U32, },
	[NLDLM_A_CFG_INACTIVE_TIMEOUT] = { .name = "inactive-timeout", .type = YNL_PT_U32, },
	[NLDLM_A_CFG_LOG_LEVEL] = { .name = "log-level", .type = YNL_PT_U32, },
	[NLDLM_A_CFG_DEFAULT_MARK] = { .name = "default-mark", .type = YNL_PT_U32, },
	[NLDLM_A_CFG_RECOVER_CALLBACKS] = { .name = "recover-callbacks", .type = YNL_PT_FLAG, },
};

struct ynl_policy_nest nldlm_cfg_nest = {
	.max_attr = NLDLM_A_CFG_MAX,
	.table = nldlm_cfg_policy,
};

/* Common nested types */
void nldlm_addr_free(struct nldlm_addr *obj)
{
	free(obj->addr6);
}

int nldlm_addr_put(struct nlmsghdr *nlh, unsigned int attr_type,
		   struct nldlm_addr *obj)
{
	struct nlattr *nest;

	nest = ynl_attr_nest_start(nlh, attr_type);
	if (obj->_present.family)
		ynl_attr_put_u16(nlh, NLDLM_A_ADDR_FAMILY, obj->family);
	if (obj->_present.addr4)
		ynl_attr_put_u32(nlh, NLDLM_A_ADDR_ADDR4, obj->addr4);
	if (obj->_present.addr6_len)
		ynl_attr_put(nlh, NLDLM_A_ADDR_ADDR6, obj->addr6, obj->_present.addr6_len);
	ynl_attr_nest_end(nlh, nest);

	return 0;
}

int nldlm_addr_parse(struct ynl_parse_arg *yarg, const struct nlattr *nested)
{
	struct nldlm_addr *dst = yarg->data;
	const struct nlattr *attr;

	ynl_attr_for_each_nested(attr, nested) {
		unsigned int type = ynl_attr_type(attr);

		if (type == NLDLM_A_ADDR_FAMILY) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.family = 1;
			dst->family = ynl_attr_get_u16(attr);
		} else if (type == NLDLM_A_ADDR_ADDR4) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.addr4 = 1;
			dst->addr4 = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_ADDR_ADDR6) {
			unsigned int len;

			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;

			len = ynl_attr_data_len(attr);
			dst->_present.addr6_len = len;
			dst->addr6 = malloc(len);
			memcpy(dst->addr6, ynl_attr_data(attr), len);
		}
	}

	return 0;
}

/* ============== NLDLM_CMD_GET_NODE ============== */
/* NLDLM_CMD_GET_NODE - do */
void nldlm_get_node_req_free(struct nldlm_get_node_req *req)
{
	free(req);
}

void nldlm_get_node_rsp_free(struct nldlm_get_node_rsp *rsp)
{
	unsigned int i;

	for (i = 0; i < rsp->n_addrs; i++)
		nldlm_addr_free(&rsp->addrs[i]);
	free(rsp->addrs);
	free(rsp);
}

int nldlm_get_node_rsp_parse(const struct nlmsghdr *nlh,
			     struct ynl_parse_arg *yarg)
{
	struct nldlm_get_node_rsp *dst;
	const struct nlattr *attr;
	struct ynl_parse_arg parg;
	unsigned int n_addrs = 0;
	int i;

	dst = yarg->data;
	parg.ys = yarg->ys;

	if (dst->addrs)
		return ynl_error_parse(yarg, "attribute already present (node.addrs)");

	ynl_attr_for_each(attr, nlh, yarg->ys->family->hdr_len) {
		unsigned int type = ynl_attr_type(attr);

		if (type == NLDLM_A_NODE_ID) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.id = 1;
			dst->id = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_NODE_MARK) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.mark = 1;
			dst->mark = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_NODE_ADDRS) {
			n_addrs++;
		}
	}

	if (n_addrs) {
		dst->addrs = calloc(n_addrs, sizeof(*dst->addrs));
		dst->n_addrs = n_addrs;
		i = 0;
		parg.rsp_policy = &nldlm_addr_nest;
		ynl_attr_for_each(attr, nlh, yarg->ys->family->hdr_len) {
			if (ynl_attr_type(attr) == NLDLM_A_NODE_ADDRS) {
				parg.data = &dst->addrs[i];
				if (nldlm_addr_parse(&parg, attr))
					return YNL_PARSE_CB_ERROR;
				i++;
			}
		}
	}

	return YNL_PARSE_CB_OK;
}

struct nldlm_get_node_rsp *
nldlm_get_node(struct ynl_sock *ys, struct nldlm_get_node_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nldlm_get_node_rsp *rsp;
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_GET_NODE, 1);
	ys->req_policy = &nldlm_node_nest;
	yrs.yarg.rsp_policy = &nldlm_node_nest;

	if (req->_present.id)
		ynl_attr_put_u32(nlh, NLDLM_A_NODE_ID, req->id);

	rsp = calloc(1, sizeof(*rsp));
	yrs.yarg.data = rsp;
	yrs.cb = nldlm_get_node_rsp_parse;
	yrs.rsp_cmd = NLDLM_CMD_GET_NODE;

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		goto err_free;

	return rsp;

err_free:
	nldlm_get_node_rsp_free(rsp);
	return NULL;
}

/* NLDLM_CMD_GET_NODE - dump */
void nldlm_get_node_list_free(struct nldlm_get_node_list *rsp)
{
	struct nldlm_get_node_list *next = rsp;

	while ((void *)next != YNL_LIST_END) {
		unsigned int i;

		rsp = next;
		next = rsp->next;

		for (i = 0; i < rsp->obj.n_addrs; i++)
			nldlm_addr_free(&rsp->obj.addrs[i]);
		free(rsp->obj.addrs);
		free(rsp);
	}
}

struct nldlm_get_node_list *nldlm_get_node_dump(struct ynl_sock *ys)
{
	struct ynl_dump_state yds = {};
	struct nlmsghdr *nlh;
	int err;

	yds.yarg.ys = ys;
	yds.yarg.rsp_policy = &nldlm_node_nest;
	yds.yarg.data = NULL;
	yds.alloc_sz = sizeof(struct nldlm_get_node_list);
	yds.cb = nldlm_get_node_rsp_parse;
	yds.rsp_cmd = NLDLM_CMD_GET_NODE;

	nlh = ynl_gemsg_start_dump(ys, ys->family_id, NLDLM_CMD_GET_NODE, 1);

	err = ynl_exec_dump(ys, nlh, &yds);
	if (err < 0)
		goto free_list;

	return yds.first;

free_list:
	nldlm_get_node_list_free(yds.first);
	return NULL;
}

/* ============== NLDLM_CMD_ADD_NODE ============== */
/* NLDLM_CMD_ADD_NODE - do */
void nldlm_add_node_req_free(struct nldlm_add_node_req *req)
{
	unsigned int i;

	for (i = 0; i < req->n_addrs; i++)
		nldlm_addr_free(&req->addrs[i]);
	free(req->addrs);
	free(req);
}

int nldlm_add_node(struct ynl_sock *ys, struct nldlm_add_node_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_ADD_NODE, 1);
	ys->req_policy = &nldlm_node_nest;

	if (req->_present.id)
		ynl_attr_put_u32(nlh, NLDLM_A_NODE_ID, req->id);
	if (req->_present.mark)
		ynl_attr_put_u32(nlh, NLDLM_A_NODE_MARK, req->mark);
	for (unsigned int i = 0; i < req->n_addrs; i++)
		nldlm_addr_put(nlh, NLDLM_A_NODE_ADDRS, &req->addrs[i]);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_DEL_NODE ============== */
/* NLDLM_CMD_DEL_NODE - do */
void nldlm_del_node_req_free(struct nldlm_del_node_req *req)
{
	free(req);
}

int nldlm_del_node(struct ynl_sock *ys, struct nldlm_del_node_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_DEL_NODE, 1);
	ys->req_policy = &nldlm_node_nest;

	if (req->_present.id)
		ynl_attr_put_u32(nlh, NLDLM_A_NODE_ID, req->id);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_GET_LS ============== */
/* NLDLM_CMD_GET_LS - do */
void nldlm_get_ls_req_free(struct nldlm_get_ls_req *req)
{
	free(req->name);
	free(req);
}

void nldlm_get_ls_rsp_free(struct nldlm_get_ls_rsp *rsp)
{
	free(rsp->name);
	free(rsp);
}

int nldlm_get_ls_rsp_parse(const struct nlmsghdr *nlh,
			   struct ynl_parse_arg *yarg)
{
	struct nldlm_get_ls_rsp *dst;
	const struct nlattr *attr;

	dst = yarg->data;

	ynl_attr_for_each(attr, nlh, yarg->ys->family->hdr_len) {
		unsigned int type = ynl_attr_type(attr);

		if (type == NLDLM_A_LS_NAME) {
			unsigned int len;

			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;

			len = strnlen(ynl_attr_get_str(attr), ynl_attr_data_len(attr));
			dst->_present.name_len = len;
			dst->name = malloc(len + 1);
			memcpy(dst->name, ynl_attr_get_str(attr), len);
			dst->name[len] = 0;
		}
	}

	return YNL_PARSE_CB_OK;
}

struct nldlm_get_ls_rsp *
nldlm_get_ls(struct ynl_sock *ys, struct nldlm_get_ls_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nldlm_get_ls_rsp *rsp;
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_GET_LS, 1);
	ys->req_policy = &nldlm_ls_nest;
	yrs.yarg.rsp_policy = &nldlm_ls_nest;

	if (req->_present.name_len)
		ynl_attr_put_str(nlh, NLDLM_A_LS_NAME, req->name);

	rsp = calloc(1, sizeof(*rsp));
	yrs.yarg.data = rsp;
	yrs.cb = nldlm_get_ls_rsp_parse;
	yrs.rsp_cmd = NLDLM_CMD_GET_LS;

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		goto err_free;

	return rsp;

err_free:
	nldlm_get_ls_rsp_free(rsp);
	return NULL;
}

/* NLDLM_CMD_GET_LS - dump */
void nldlm_get_ls_list_free(struct nldlm_get_ls_list *rsp)
{
	struct nldlm_get_ls_list *next = rsp;

	while ((void *)next != YNL_LIST_END) {
		rsp = next;
		next = rsp->next;

		free(rsp->obj.name);
		free(rsp);
	}
}

struct nldlm_get_ls_list *nldlm_get_ls_dump(struct ynl_sock *ys)
{
	struct ynl_dump_state yds = {};
	struct nlmsghdr *nlh;
	int err;

	yds.yarg.ys = ys;
	yds.yarg.rsp_policy = &nldlm_ls_nest;
	yds.yarg.data = NULL;
	yds.alloc_sz = sizeof(struct nldlm_get_ls_list);
	yds.cb = nldlm_get_ls_rsp_parse;
	yds.rsp_cmd = NLDLM_CMD_GET_LS;

	nlh = ynl_gemsg_start_dump(ys, ys->family_id, NLDLM_CMD_GET_LS, 1);

	err = ynl_exec_dump(ys, nlh, &yds);
	if (err < 0)
		goto free_list;

	return yds.first;

free_list:
	nldlm_get_ls_list_free(yds.first);
	return NULL;
}

/* NLDLM_CMD_GET_LS - notify */
void nldlm_get_ls_ntf_free(struct nldlm_get_ls_ntf *rsp)
{
	free(rsp->obj.name);
	free(rsp);
}

/* ============== NLDLM_CMD_GET_LS_MEMBER ============== */
/* NLDLM_CMD_GET_LS_MEMBER - do */
void nldlm_get_ls_member_req_free(struct nldlm_get_ls_member_req *req)
{
	free(req->ls_name);
	free(req);
}

void nldlm_get_ls_member_rsp_free(struct nldlm_get_ls_member_rsp *rsp)
{
	free(rsp->ls_name);
	free(rsp);
}

int nldlm_get_ls_member_rsp_parse(const struct nlmsghdr *nlh,
				  struct ynl_parse_arg *yarg)
{
	struct nldlm_get_ls_member_rsp *dst;
	const struct nlattr *attr;

	dst = yarg->data;

	ynl_attr_for_each(attr, nlh, yarg->ys->family->hdr_len) {
		unsigned int type = ynl_attr_type(attr);

		if (type == NLDLM_A_LS_MEMBER_LS_NAME) {
			unsigned int len;

			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;

			len = strnlen(ynl_attr_get_str(attr), ynl_attr_data_len(attr));
			dst->_present.ls_name_len = len;
			dst->ls_name = malloc(len + 1);
			memcpy(dst->ls_name, ynl_attr_get_str(attr), len);
			dst->ls_name[len] = 0;
		} else if (type == NLDLM_A_LS_MEMBER_NODEID) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.nodeid = 1;
			dst->nodeid = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_LS_MEMBER_WEIGHT) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.weight = 1;
			dst->weight = ynl_attr_get_u32(attr);
		}
	}

	return YNL_PARSE_CB_OK;
}

struct nldlm_get_ls_member_rsp *
nldlm_get_ls_member(struct ynl_sock *ys, struct nldlm_get_ls_member_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nldlm_get_ls_member_rsp *rsp;
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_GET_LS_MEMBER, 1);
	ys->req_policy = &nldlm_ls_member_nest;
	yrs.yarg.rsp_policy = &nldlm_ls_member_nest;

	if (req->_present.ls_name_len)
		ynl_attr_put_str(nlh, NLDLM_A_LS_MEMBER_LS_NAME, req->ls_name);
	if (req->_present.nodeid)
		ynl_attr_put_u32(nlh, NLDLM_A_LS_MEMBER_NODEID, req->nodeid);

	rsp = calloc(1, sizeof(*rsp));
	yrs.yarg.data = rsp;
	yrs.cb = nldlm_get_ls_member_rsp_parse;
	yrs.rsp_cmd = NLDLM_CMD_GET_LS_MEMBER;

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		goto err_free;

	return rsp;

err_free:
	nldlm_get_ls_member_rsp_free(rsp);
	return NULL;
}

/* NLDLM_CMD_GET_LS_MEMBER - dump */
void
nldlm_get_ls_member_req_dump_free(struct nldlm_get_ls_member_req_dump *req)
{
	free(req->ls_name);
	free(req);
}

void nldlm_get_ls_member_list_free(struct nldlm_get_ls_member_list *rsp)
{
	struct nldlm_get_ls_member_list *next = rsp;

	while ((void *)next != YNL_LIST_END) {
		rsp = next;
		next = rsp->next;

		free(rsp->obj.ls_name);
		free(rsp);
	}
}

struct nldlm_get_ls_member_list *
nldlm_get_ls_member_dump(struct ynl_sock *ys,
			 struct nldlm_get_ls_member_req_dump *req)
{
	struct ynl_dump_state yds = {};
	struct nlmsghdr *nlh;
	int err;

	yds.yarg.ys = ys;
	yds.yarg.rsp_policy = &nldlm_ls_member_nest;
	yds.yarg.data = NULL;
	yds.alloc_sz = sizeof(struct nldlm_get_ls_member_list);
	yds.cb = nldlm_get_ls_member_rsp_parse;
	yds.rsp_cmd = NLDLM_CMD_GET_LS_MEMBER;

	nlh = ynl_gemsg_start_dump(ys, ys->family_id, NLDLM_CMD_GET_LS_MEMBER, 1);
	ys->req_policy = &nldlm_ls_member_nest;

	if (req->_present.ls_name_len)
		ynl_attr_put_str(nlh, NLDLM_A_LS_MEMBER_LS_NAME, req->ls_name);

	err = ynl_exec_dump(ys, nlh, &yds);
	if (err < 0)
		goto free_list;

	return yds.first;

free_list:
	nldlm_get_ls_member_list_free(yds.first);
	return NULL;
}

/* ============== NLDLM_CMD_LS_ADD_MEMBER ============== */
/* NLDLM_CMD_LS_ADD_MEMBER - do */
void nldlm_ls_add_member_req_free(struct nldlm_ls_add_member_req *req)
{
	free(req->ls_name);
	free(req);
}

int nldlm_ls_add_member(struct ynl_sock *ys,
			struct nldlm_ls_add_member_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_LS_ADD_MEMBER, 1);
	ys->req_policy = &nldlm_ls_member_nest;

	if (req->_present.ls_name_len)
		ynl_attr_put_str(nlh, NLDLM_A_LS_MEMBER_LS_NAME, req->ls_name);
	if (req->_present.nodeid)
		ynl_attr_put_u32(nlh, NLDLM_A_LS_MEMBER_NODEID, req->nodeid);
	if (req->_present.weight)
		ynl_attr_put_u32(nlh, NLDLM_A_LS_MEMBER_WEIGHT, req->weight);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_LS_DEL_MEMBER ============== */
/* NLDLM_CMD_LS_DEL_MEMBER - do */
void nldlm_ls_del_member_req_free(struct nldlm_ls_del_member_req *req)
{
	free(req->ls_name);
	free(req);
}

int nldlm_ls_del_member(struct ynl_sock *ys,
			struct nldlm_ls_del_member_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_LS_DEL_MEMBER, 1);
	ys->req_policy = &nldlm_ls_member_nest;

	if (req->_present.ls_name_len)
		ynl_attr_put_str(nlh, NLDLM_A_LS_MEMBER_LS_NAME, req->ls_name);
	if (req->_present.nodeid)
		ynl_attr_put_u32(nlh, NLDLM_A_LS_MEMBER_NODEID, req->nodeid);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_LS_CTRL ============== */
/* NLDLM_CMD_LS_CTRL - do */
void nldlm_ls_ctrl_req_free(struct nldlm_ls_ctrl_req *req)
{
	free(req->ls_name);
	free(req);
}

int nldlm_ls_ctrl(struct ynl_sock *ys, struct nldlm_ls_ctrl_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_LS_CTRL, 1);
	ys->req_policy = &nldlm_ls_ctrl_nest;

	if (req->_present.ls_name_len)
		ynl_attr_put_str(nlh, NLDLM_A_LS_CTRL_LS_NAME, req->ls_name);
	if (req->_present.action)
		ynl_attr_put_u32(nlh, NLDLM_A_LS_CTRL_ACTION, req->action);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_LS_EVENT_DONE ============== */
/* NLDLM_CMD_LS_EVENT_DONE - do */
void nldlm_ls_event_done_req_free(struct nldlm_ls_event_done_req *req)
{
	free(req->ls_name);
	free(req);
}

int nldlm_ls_event_done(struct ynl_sock *ys,
			struct nldlm_ls_event_done_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_LS_EVENT_DONE, 1);
	ys->req_policy = &nldlm_ls_event_result_nest;

	if (req->_present.ls_name_len)
		ynl_attr_put_str(nlh, NLDLM_A_LS_EVENT_RESULT_LS_NAME, req->ls_name);
	if (req->_present.ls_global_id)
		ynl_attr_put_u32(nlh, NLDLM_A_LS_EVENT_RESULT_LS_GLOBAL_ID, req->ls_global_id);
	if (req->_present.result)
		ynl_attr_put_u32(nlh, NLDLM_A_LS_EVENT_RESULT_RESULT, req->result);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_GET_CFG ============== */
/* NLDLM_CMD_GET_CFG - do */
void nldlm_get_cfg_rsp_free(struct nldlm_get_cfg_rsp *rsp)
{
	free(rsp->cluster_name);
	free(rsp);
}

int nldlm_get_cfg_rsp_parse(const struct nlmsghdr *nlh,
			    struct ynl_parse_arg *yarg)
{
	struct nldlm_get_cfg_rsp *dst;
	const struct nlattr *attr;

	dst = yarg->data;

	ynl_attr_for_each(attr, nlh, yarg->ys->family->hdr_len) {
		unsigned int type = ynl_attr_type(attr);

		if (type == NLDLM_A_CFG_OUR_NODEID) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.our_nodeid = 1;
			dst->our_nodeid = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_CFG_CLUSTER_NAME) {
			unsigned int len;

			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;

			len = strnlen(ynl_attr_get_str(attr), ynl_attr_data_len(attr));
			dst->_present.cluster_name_len = len;
			dst->cluster_name = malloc(len + 1);
			memcpy(dst->cluster_name, ynl_attr_get_str(attr), len);
			dst->cluster_name[len] = 0;
		} else if (type == NLDLM_A_CFG_PROTOCOL) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.protocol = 1;
			dst->protocol = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_CFG_PORT) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.port = 1;
			dst->port = ynl_attr_get_u16(attr);
		} else if (type == NLDLM_A_CFG_RECOVER_TIMEOUT) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.recover_timeout = 1;
			dst->recover_timeout = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_CFG_INACTIVE_TIMEOUT) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.inactive_timeout = 1;
			dst->inactive_timeout = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_CFG_LOG_LEVEL) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.log_level = 1;
			dst->log_level = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_CFG_DEFAULT_MARK) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.default_mark = 1;
			dst->default_mark = ynl_attr_get_u32(attr);
		} else if (type == NLDLM_A_CFG_RECOVER_CALLBACKS) {
			if (ynl_attr_validate(yarg, attr))
				return YNL_PARSE_CB_ERROR;
			dst->_present.recover_callbacks = 1;
		}
	}

	return YNL_PARSE_CB_OK;
}

struct nldlm_get_cfg_rsp *nldlm_get_cfg(struct ynl_sock *ys)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nldlm_get_cfg_rsp *rsp;
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_GET_CFG, 1);
	ys->req_policy = &nldlm_cfg_nest;
	yrs.yarg.rsp_policy = &nldlm_cfg_nest;

	rsp = calloc(1, sizeof(*rsp));
	yrs.yarg.data = rsp;
	yrs.cb = nldlm_get_cfg_rsp_parse;
	yrs.rsp_cmd = NLDLM_CMD_GET_CFG;

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		goto err_free;

	return rsp;

err_free:
	nldlm_get_cfg_rsp_free(rsp);
	return NULL;
}

/* ============== NLDLM_CMD_SET_OUR_NODEID ============== */
/* NLDLM_CMD_SET_OUR_NODEID - do */
void nldlm_set_our_nodeid_req_free(struct nldlm_set_our_nodeid_req *req)
{
	free(req);
}

int nldlm_set_our_nodeid(struct ynl_sock *ys,
			 struct nldlm_set_our_nodeid_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_OUR_NODEID, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.our_nodeid)
		ynl_attr_put_u32(nlh, NLDLM_A_CFG_OUR_NODEID, req->our_nodeid);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_CLUSTER_NAME ============== */
/* NLDLM_CMD_SET_CLUSTER_NAME - do */
void nldlm_set_cluster_name_req_free(struct nldlm_set_cluster_name_req *req)
{
	free(req->cluster_name);
	free(req);
}

int nldlm_set_cluster_name(struct ynl_sock *ys,
			   struct nldlm_set_cluster_name_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_CLUSTER_NAME, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.cluster_name_len)
		ynl_attr_put_str(nlh, NLDLM_A_CFG_CLUSTER_NAME, req->cluster_name);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_PROTOCOL ============== */
/* NLDLM_CMD_SET_PROTOCOL - do */
void nldlm_set_protocol_req_free(struct nldlm_set_protocol_req *req)
{
	free(req);
}

int nldlm_set_protocol(struct ynl_sock *ys, struct nldlm_set_protocol_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_PROTOCOL, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.protocol)
		ynl_attr_put_u32(nlh, NLDLM_A_CFG_PROTOCOL, req->protocol);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_PORT ============== */
/* NLDLM_CMD_SET_PORT - do */
void nldlm_set_port_req_free(struct nldlm_set_port_req *req)
{
	free(req);
}

int nldlm_set_port(struct ynl_sock *ys, struct nldlm_set_port_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_PORT, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.port)
		ynl_attr_put_u16(nlh, NLDLM_A_CFG_PORT, req->port);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_RECOVER_TIMEOUT ============== */
/* NLDLM_CMD_SET_RECOVER_TIMEOUT - do */
void
nldlm_set_recover_timeout_req_free(struct nldlm_set_recover_timeout_req *req)
{
	free(req);
}

int nldlm_set_recover_timeout(struct ynl_sock *ys,
			      struct nldlm_set_recover_timeout_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_RECOVER_TIMEOUT, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.recover_timeout)
		ynl_attr_put_u32(nlh, NLDLM_A_CFG_RECOVER_TIMEOUT, req->recover_timeout);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_INACTIVE_TIMEOUT ============== */
/* NLDLM_CMD_SET_INACTIVE_TIMEOUT - do */
void
nldlm_set_inactive_timeout_req_free(struct nldlm_set_inactive_timeout_req *req)
{
	free(req);
}

int nldlm_set_inactive_timeout(struct ynl_sock *ys,
			       struct nldlm_set_inactive_timeout_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_INACTIVE_TIMEOUT, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.inactive_timeout)
		ynl_attr_put_u32(nlh, NLDLM_A_CFG_INACTIVE_TIMEOUT, req->inactive_timeout);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_LOG_LEVEL ============== */
/* NLDLM_CMD_SET_LOG_LEVEL - do */
void nldlm_set_log_level_req_free(struct nldlm_set_log_level_req *req)
{
	free(req);
}

int nldlm_set_log_level(struct ynl_sock *ys,
			struct nldlm_set_log_level_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_LOG_LEVEL, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.log_level)
		ynl_attr_put_u32(nlh, NLDLM_A_CFG_LOG_LEVEL, req->log_level);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_DEFAULT_MARK ============== */
/* NLDLM_CMD_SET_DEFAULT_MARK - do */
void nldlm_set_default_mark_req_free(struct nldlm_set_default_mark_req *req)
{
	free(req);
}

int nldlm_set_default_mark(struct ynl_sock *ys,
			   struct nldlm_set_default_mark_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_DEFAULT_MARK, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.default_mark)
		ynl_attr_put_u32(nlh, NLDLM_A_CFG_DEFAULT_MARK, req->default_mark);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

/* ============== NLDLM_CMD_SET_RECOVER_CALLBACKS ============== */
/* NLDLM_CMD_SET_RECOVER_CALLBACKS - do */
void
nldlm_set_recover_callbacks_req_free(struct nldlm_set_recover_callbacks_req *req)
{
	free(req);
}

int nldlm_set_recover_callbacks(struct ynl_sock *ys,
				struct nldlm_set_recover_callbacks_req *req)
{
	struct ynl_req_state yrs = { .yarg = { .ys = ys, }, };
	struct nlmsghdr *nlh;
	int err;

	nlh = ynl_gemsg_start_req(ys, ys->family_id, NLDLM_CMD_SET_RECOVER_CALLBACKS, 1);
	ys->req_policy = &nldlm_cfg_nest;

	if (req->_present.recover_callbacks)
		ynl_attr_put(nlh, NLDLM_A_CFG_RECOVER_CALLBACKS, NULL, 0);

	err = ynl_exec(ys, nlh, &yrs);
	if (err < 0)
		return -1;

	return 0;
}

static const struct ynl_ntf_info nldlm_ntf_info[] =  {
	[NLDLM_CMD_NTF_NEW_LS] =  {
		.alloc_sz	= sizeof(struct nldlm_get_ls_ntf),
		.cb		= nldlm_get_ls_rsp_parse,
		.policy		= &nldlm_ls_nest,
		.free		= (void *)nldlm_get_ls_ntf_free,
	},
	[NLDLM_CMD_NTF_RELEASE_LS] =  {
		.alloc_sz	= sizeof(struct nldlm_get_ls_ntf),
		.cb		= nldlm_get_ls_rsp_parse,
		.policy		= &nldlm_ls_nest,
		.free		= (void *)nldlm_get_ls_ntf_free,
	},
};

const struct ynl_family ynl_nldlm_family =  {
	.name		= "nldlm",
	.hdr_len	= sizeof(struct genlmsghdr),
	.ntf_info	= nldlm_ntf_info,
	.ntf_info_size	= YNL_ARRAY_SIZE(nldlm_ntf_info),
};
