/* SPDX-License-Identifier: ((GPL-2.0 WITH Linux-syscall-note) OR BSD-3-Clause) */
/* Do not edit directly, auto-generated from: */
/*	Documentation/netlink/specs/nldlm.yaml */
/* YNL-GEN user header */

#ifndef _LINUX_NLDLM_GEN_H
#define _LINUX_NLDLM_GEN_H

#include <stdlib.h>
#include <string.h>
#include <linux/types.h>
#include <linux/nldlm.h>

struct ynl_sock;

extern const struct ynl_family ynl_nldlm_family;

/* Enums */
const char *nldlm_op_str(int op);
const char *nldlm_protocol_str(enum nldlm_protocol value);
const char *nldlm_log_level_str(enum nldlm_log_level value);
const char *nldlm_ls_ctrl_action_str(enum nldlm_ls_ctrl_action value);
const char *nldlm_ls_event_result_str(enum nldlm_ls_event_result value);

/* Common nested types */
struct nldlm_addr {
	struct {
		__u32 family:1;
		__u32 addr4:1;
		__u32 addr6_len;
	} _present;

	__u16 family;
	__u32 addr4 /* big-endian */;
	void *addr6;
};

/* ============== NLDLM_CMD_GET_NODE ============== */
/* NLDLM_CMD_GET_NODE - do */
struct nldlm_get_node_req {
	struct {
		__u32 id:1;
	} _present;

	__u32 id /* little-endian */;
};

static inline struct nldlm_get_node_req *nldlm_get_node_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_get_node_req));
}
void nldlm_get_node_req_free(struct nldlm_get_node_req *req);

static inline void
nldlm_get_node_req_set_id(struct nldlm_get_node_req *req,
			  __u32 id /* little-endian */)
{
	req->_present.id = 1;
	req->id = id;
}

struct nldlm_get_node_rsp {
	struct {
		__u32 id:1;
		__u32 mark:1;
	} _present;

	__u32 id /* little-endian */;
	__u32 mark;
	unsigned int n_addrs;
	struct nldlm_addr *addrs;
};

void nldlm_get_node_rsp_free(struct nldlm_get_node_rsp *rsp);

/*
 * get DLM node information from the kernel configuration.

 */
struct nldlm_get_node_rsp *
nldlm_get_node(struct ynl_sock *ys, struct nldlm_get_node_req *req);

/* NLDLM_CMD_GET_NODE - dump */
struct nldlm_get_node_list {
	struct nldlm_get_node_list *next;
	struct nldlm_get_node_rsp obj __attribute__((aligned(8)));
};

void nldlm_get_node_list_free(struct nldlm_get_node_list *rsp);

struct nldlm_get_node_list *nldlm_get_node_dump(struct ynl_sock *ys);

/* ============== NLDLM_CMD_ADD_NODE ============== */
/* NLDLM_CMD_ADD_NODE - do */
struct nldlm_add_node_req {
	struct {
		__u32 id:1;
		__u32 mark:1;
	} _present;

	__u32 id /* little-endian */;
	__u32 mark;
	unsigned int n_addrs;
	struct nldlm_addr *addrs;
};

static inline struct nldlm_add_node_req *nldlm_add_node_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_add_node_req));
}
void nldlm_add_node_req_free(struct nldlm_add_node_req *req);

static inline void
nldlm_add_node_req_set_id(struct nldlm_add_node_req *req,
			  __u32 id /* little-endian */)
{
	req->_present.id = 1;
	req->id = id;
}
static inline void
nldlm_add_node_req_set_mark(struct nldlm_add_node_req *req, __u32 mark)
{
	req->_present.mark = 1;
	req->mark = mark;
}
static inline void
__nldlm_add_node_req_set_addrs(struct nldlm_add_node_req *req,
			       struct nldlm_addr *addrs, unsigned int n_addrs)
{
	free(req->addrs);
	req->addrs = addrs;
	req->n_addrs = n_addrs;
}

/*
 * add a new DLM node to the kernel configuration.

 */
int nldlm_add_node(struct ynl_sock *ys, struct nldlm_add_node_req *req);

/* ============== NLDLM_CMD_DEL_NODE ============== */
/* NLDLM_CMD_DEL_NODE - do */
struct nldlm_del_node_req {
	struct {
		__u32 id:1;
	} _present;

	__u32 id /* little-endian */;
};

static inline struct nldlm_del_node_req *nldlm_del_node_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_del_node_req));
}
void nldlm_del_node_req_free(struct nldlm_del_node_req *req);

static inline void
nldlm_del_node_req_set_id(struct nldlm_del_node_req *req,
			  __u32 id /* little-endian */)
{
	req->_present.id = 1;
	req->id = id;
}

/*
 * delete a DLM node from the kernel configuration.

 */
int nldlm_del_node(struct ynl_sock *ys, struct nldlm_del_node_req *req);

/* ============== NLDLM_CMD_GET_LS ============== */
/* NLDLM_CMD_GET_LS - do */
struct nldlm_get_ls_req {
	struct {
		__u32 name_len;
	} _present;

	char *name;
};

static inline struct nldlm_get_ls_req *nldlm_get_ls_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_get_ls_req));
}
void nldlm_get_ls_req_free(struct nldlm_get_ls_req *req);

static inline void
nldlm_get_ls_req_set_name(struct nldlm_get_ls_req *req, const char *name)
{
	free(req->name);
	req->_present.name_len = strlen(name);
	req->name = malloc(req->_present.name_len + 1);
	memcpy(req->name, name, req->_present.name_len);
	req->name[req->_present.name_len] = 0;
}

struct nldlm_get_ls_rsp {
	struct {
		__u32 name_len;
	} _present;

	char *name;
};

void nldlm_get_ls_rsp_free(struct nldlm_get_ls_rsp *rsp);

/*
 * get registered DLM lockspace information.

 */
struct nldlm_get_ls_rsp *
nldlm_get_ls(struct ynl_sock *ys, struct nldlm_get_ls_req *req);

/* NLDLM_CMD_GET_LS - dump */
struct nldlm_get_ls_list {
	struct nldlm_get_ls_list *next;
	struct nldlm_get_ls_rsp obj __attribute__((aligned(8)));
};

void nldlm_get_ls_list_free(struct nldlm_get_ls_list *rsp);

struct nldlm_get_ls_list *nldlm_get_ls_dump(struct ynl_sock *ys);

/* NLDLM_CMD_GET_LS - notify */
struct nldlm_get_ls_ntf {
	__u16 family;
	__u8 cmd;
	struct ynl_ntf_base_type *next;
	void (*free)(struct nldlm_get_ls_ntf *ntf);
	struct nldlm_get_ls_rsp obj __attribute__((aligned(8)));
};

void nldlm_get_ls_ntf_free(struct nldlm_get_ls_ntf *rsp);

/* ============== NLDLM_CMD_GET_LS_MEMBER ============== */
/* NLDLM_CMD_GET_LS_MEMBER - do */
struct nldlm_get_ls_member_req {
	struct {
		__u32 ls_name_len;
		__u32 nodeid:1;
	} _present;

	char *ls_name;
	__u32 nodeid /* little-endian */;
};

static inline struct nldlm_get_ls_member_req *
nldlm_get_ls_member_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_get_ls_member_req));
}
void nldlm_get_ls_member_req_free(struct nldlm_get_ls_member_req *req);

static inline void
nldlm_get_ls_member_req_set_ls_name(struct nldlm_get_ls_member_req *req,
				    const char *ls_name)
{
	free(req->ls_name);
	req->_present.ls_name_len = strlen(ls_name);
	req->ls_name = malloc(req->_present.ls_name_len + 1);
	memcpy(req->ls_name, ls_name, req->_present.ls_name_len);
	req->ls_name[req->_present.ls_name_len] = 0;
}
static inline void
nldlm_get_ls_member_req_set_nodeid(struct nldlm_get_ls_member_req *req,
				   __u32 nodeid /* little-endian */)
{
	req->_present.nodeid = 1;
	req->nodeid = nodeid;
}

struct nldlm_get_ls_member_rsp {
	struct {
		__u32 ls_name_len;
		__u32 nodeid:1;
		__u32 weight:1;
	} _present;

	char *ls_name;
	__u32 nodeid /* little-endian */;
	__u32 weight;
};

void nldlm_get_ls_member_rsp_free(struct nldlm_get_ls_member_rsp *rsp);

/*
 * get members information from a registered DLM lockspace.

 */
struct nldlm_get_ls_member_rsp *
nldlm_get_ls_member(struct ynl_sock *ys, struct nldlm_get_ls_member_req *req);

/* NLDLM_CMD_GET_LS_MEMBER - dump */
struct nldlm_get_ls_member_req_dump {
	struct {
		__u32 ls_name_len;
	} _present;

	char *ls_name;
};

static inline struct nldlm_get_ls_member_req_dump *
nldlm_get_ls_member_req_dump_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_get_ls_member_req_dump));
}
void
nldlm_get_ls_member_req_dump_free(struct nldlm_get_ls_member_req_dump *req);

static inline void
nldlm_get_ls_member_req_dump_set_ls_name(struct nldlm_get_ls_member_req_dump *req,
					 const char *ls_name)
{
	free(req->ls_name);
	req->_present.ls_name_len = strlen(ls_name);
	req->ls_name = malloc(req->_present.ls_name_len + 1);
	memcpy(req->ls_name, ls_name, req->_present.ls_name_len);
	req->ls_name[req->_present.ls_name_len] = 0;
}

struct nldlm_get_ls_member_list {
	struct nldlm_get_ls_member_list *next;
	struct nldlm_get_ls_member_rsp obj __attribute__((aligned(8)));
};

void nldlm_get_ls_member_list_free(struct nldlm_get_ls_member_list *rsp);

struct nldlm_get_ls_member_list *
nldlm_get_ls_member_dump(struct ynl_sock *ys,
			 struct nldlm_get_ls_member_req_dump *req);

/* ============== NLDLM_CMD_LS_ADD_MEMBER ============== */
/* NLDLM_CMD_LS_ADD_MEMBER - do */
struct nldlm_ls_add_member_req {
	struct {
		__u32 ls_name_len;
		__u32 nodeid:1;
		__u32 weight:1;
	} _present;

	char *ls_name;
	__u32 nodeid /* little-endian */;
	__u32 weight;
};

static inline struct nldlm_ls_add_member_req *
nldlm_ls_add_member_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_ls_add_member_req));
}
void nldlm_ls_add_member_req_free(struct nldlm_ls_add_member_req *req);

static inline void
nldlm_ls_add_member_req_set_ls_name(struct nldlm_ls_add_member_req *req,
				    const char *ls_name)
{
	free(req->ls_name);
	req->_present.ls_name_len = strlen(ls_name);
	req->ls_name = malloc(req->_present.ls_name_len + 1);
	memcpy(req->ls_name, ls_name, req->_present.ls_name_len);
	req->ls_name[req->_present.ls_name_len] = 0;
}
static inline void
nldlm_ls_add_member_req_set_nodeid(struct nldlm_ls_add_member_req *req,
				   __u32 nodeid /* little-endian */)
{
	req->_present.nodeid = 1;
	req->nodeid = nodeid;
}
static inline void
nldlm_ls_add_member_req_set_weight(struct nldlm_ls_add_member_req *req,
				   __u32 weight)
{
	req->_present.weight = 1;
	req->weight = weight;
}

/*
 * add a member to a specific registered lockspace. Should be used
when the lockspaces is stopped.

 */
int nldlm_ls_add_member(struct ynl_sock *ys,
			struct nldlm_ls_add_member_req *req);

/* ============== NLDLM_CMD_LS_DEL_MEMBER ============== */
/* NLDLM_CMD_LS_DEL_MEMBER - do */
struct nldlm_ls_del_member_req {
	struct {
		__u32 ls_name_len;
		__u32 nodeid:1;
	} _present;

	char *ls_name;
	__u32 nodeid /* little-endian */;
};

static inline struct nldlm_ls_del_member_req *
nldlm_ls_del_member_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_ls_del_member_req));
}
void nldlm_ls_del_member_req_free(struct nldlm_ls_del_member_req *req);

static inline void
nldlm_ls_del_member_req_set_ls_name(struct nldlm_ls_del_member_req *req,
				    const char *ls_name)
{
	free(req->ls_name);
	req->_present.ls_name_len = strlen(ls_name);
	req->ls_name = malloc(req->_present.ls_name_len + 1);
	memcpy(req->ls_name, ls_name, req->_present.ls_name_len);
	req->ls_name[req->_present.ls_name_len] = 0;
}
static inline void
nldlm_ls_del_member_req_set_nodeid(struct nldlm_ls_del_member_req *req,
				   __u32 nodeid /* little-endian */)
{
	req->_present.nodeid = 1;
	req->nodeid = nodeid;
}

/*
 * delete a member to a specific registered lockspace. Should be used
when the lockspaces is stopped.

 */
int nldlm_ls_del_member(struct ynl_sock *ys,
			struct nldlm_ls_del_member_req *req);

/* ============== NLDLM_CMD_LS_CTRL ============== */
/* NLDLM_CMD_LS_CTRL - do */
struct nldlm_ls_ctrl_req {
	struct {
		__u32 ls_name_len;
		__u32 action:1;
	} _present;

	char *ls_name;
	__u32 action;
};

static inline struct nldlm_ls_ctrl_req *nldlm_ls_ctrl_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_ls_ctrl_req));
}
void nldlm_ls_ctrl_req_free(struct nldlm_ls_ctrl_req *req);

static inline void
nldlm_ls_ctrl_req_set_ls_name(struct nldlm_ls_ctrl_req *req,
			      const char *ls_name)
{
	free(req->ls_name);
	req->_present.ls_name_len = strlen(ls_name);
	req->ls_name = malloc(req->_present.ls_name_len + 1);
	memcpy(req->ls_name, ls_name, req->_present.ls_name_len);
	req->ls_name[req->_present.ls_name_len] = 0;
}
static inline void
nldlm_ls_ctrl_req_set_action(struct nldlm_ls_ctrl_req *req, __u32 action)
{
	req->_present.action = 1;
	req->action = action;
}

/*
 * do lockspace control actions like stop and start lockspace for
membership updates.

 */
int nldlm_ls_ctrl(struct ynl_sock *ys, struct nldlm_ls_ctrl_req *req);

/* ============== NLDLM_CMD_LS_EVENT_DONE ============== */
/* NLDLM_CMD_LS_EVENT_DONE - do */
struct nldlm_ls_event_done_req {
	struct {
		__u32 ls_name_len;
		__u32 ls_global_id:1;
		__u32 result:1;
	} _present;

	char *ls_name;
	__u32 ls_global_id /* little-endian */;
	__u32 result;
};

static inline struct nldlm_ls_event_done_req *
nldlm_ls_event_done_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_ls_event_done_req));
}
void nldlm_ls_event_done_req_free(struct nldlm_ls_event_done_req *req);

static inline void
nldlm_ls_event_done_req_set_ls_name(struct nldlm_ls_event_done_req *req,
				    const char *ls_name)
{
	free(req->ls_name);
	req->_present.ls_name_len = strlen(ls_name);
	req->ls_name = malloc(req->_present.ls_name_len + 1);
	memcpy(req->ls_name, ls_name, req->_present.ls_name_len);
	req->ls_name[req->_present.ls_name_len] = 0;
}
static inline void
nldlm_ls_event_done_req_set_ls_global_id(struct nldlm_ls_event_done_req *req,
					 __u32 ls_global_id /* little-endian */)
{
	req->_present.ls_global_id = 1;
	req->ls_global_id = ls_global_id;
}
static inline void
nldlm_ls_event_done_req_set_result(struct nldlm_ls_event_done_req *req,
				   __u32 result)
{
	req->_present.result = 1;
	req->result = result;
}

/*
 * send back the result from the user space of the ntf-new-ls or
ntf-release-ls ls-event. The user space can decide to accept
or reject the lockspace creation. Sending the result back requires
to tell the DLM lockspace the cluster-wide unique global-id.

 */
int nldlm_ls_event_done(struct ynl_sock *ys,
			struct nldlm_ls_event_done_req *req);

/* ============== NLDLM_CMD_GET_CFG ============== */
/* NLDLM_CMD_GET_CFG - do */

struct nldlm_get_cfg_rsp {
	struct {
		__u32 our_nodeid:1;
		__u32 cluster_name_len;
		__u32 protocol:1;
		__u32 port:1;
		__u32 recover_timeout:1;
		__u32 inactive_timeout:1;
		__u32 log_level:1;
		__u32 default_mark:1;
		__u32 recover_callbacks:1;
	} _present;

	__u32 our_nodeid /* little-endian */;
	char *cluster_name;
	__u32 protocol;
	__u16 port /* big-endian */;
	__u32 recover_timeout;
	__u32 inactive_timeout;
	__u32 log_level;
	__u32 default_mark;
};

void nldlm_get_cfg_rsp_free(struct nldlm_get_cfg_rsp *rsp);

/*
 * get the current DLM kernel configuration attributes.

 */
struct nldlm_get_cfg_rsp *nldlm_get_cfg(struct ynl_sock *ys);

/* ============== NLDLM_CMD_SET_OUR_NODEID ============== */
/* NLDLM_CMD_SET_OUR_NODEID - do */
struct nldlm_set_our_nodeid_req {
	struct {
		__u32 our_nodeid:1;
	} _present;

	__u32 our_nodeid /* little-endian */;
};

static inline struct nldlm_set_our_nodeid_req *
nldlm_set_our_nodeid_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_our_nodeid_req));
}
void nldlm_set_our_nodeid_req_free(struct nldlm_set_our_nodeid_req *req);

static inline void
nldlm_set_our_nodeid_req_set_our_nodeid(struct nldlm_set_our_nodeid_req *req,
					__u32 our_nodeid /* little-endian */)
{
	req->_present.our_nodeid = 1;
	req->our_nodeid = our_nodeid;
}

/*
 * set our nodeid. The node need to be part of the DLM registered
nodes.

 */
int nldlm_set_our_nodeid(struct ynl_sock *ys,
			 struct nldlm_set_our_nodeid_req *req);

/* ============== NLDLM_CMD_SET_CLUSTER_NAME ============== */
/* NLDLM_CMD_SET_CLUSTER_NAME - do */
struct nldlm_set_cluster_name_req {
	struct {
		__u32 cluster_name_len;
	} _present;

	char *cluster_name;
};

static inline struct nldlm_set_cluster_name_req *
nldlm_set_cluster_name_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_cluster_name_req));
}
void nldlm_set_cluster_name_req_free(struct nldlm_set_cluster_name_req *req);

static inline void
nldlm_set_cluster_name_req_set_cluster_name(struct nldlm_set_cluster_name_req *req,
					    const char *cluster_name)
{
	free(req->cluster_name);
	req->_present.cluster_name_len = strlen(cluster_name);
	req->cluster_name = malloc(req->_present.cluster_name_len + 1);
	memcpy(req->cluster_name, cluster_name, req->_present.cluster_name_len);
	req->cluster_name[req->_present.cluster_name_len] = 0;
}

/*
 * set the DLM cluster name.

 */
int nldlm_set_cluster_name(struct ynl_sock *ys,
			   struct nldlm_set_cluster_name_req *req);

/* ============== NLDLM_CMD_SET_PROTOCOL ============== */
/* NLDLM_CMD_SET_PROTOCOL - do */
struct nldlm_set_protocol_req {
	struct {
		__u32 protocol:1;
	} _present;

	__u32 protocol;
};

static inline struct nldlm_set_protocol_req *nldlm_set_protocol_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_protocol_req));
}
void nldlm_set_protocol_req_free(struct nldlm_set_protocol_req *req);

static inline void
nldlm_set_protocol_req_set_protocol(struct nldlm_set_protocol_req *req,
				    __u32 protocol)
{
	req->_present.protocol = 1;
	req->protocol = protocol;
}

/*
 * set the DLM used transportation protocol.

 */
int nldlm_set_protocol(struct ynl_sock *ys, struct nldlm_set_protocol_req *req);

/* ============== NLDLM_CMD_SET_PORT ============== */
/* NLDLM_CMD_SET_PORT - do */
struct nldlm_set_port_req {
	struct {
		__u32 port:1;
	} _present;

	__u16 port /* big-endian */;
};

static inline struct nldlm_set_port_req *nldlm_set_port_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_port_req));
}
void nldlm_set_port_req_free(struct nldlm_set_port_req *req);

static inline void
nldlm_set_port_req_set_port(struct nldlm_set_port_req *req,
			    __u16 port /* big-endian */)
{
	req->_present.port = 1;
	req->port = port;
}

/*
 * set the DLM port to listen for the used transportation protocol.

 */
int nldlm_set_port(struct ynl_sock *ys, struct nldlm_set_port_req *req);

/* ============== NLDLM_CMD_SET_RECOVER_TIMEOUT ============== */
/* NLDLM_CMD_SET_RECOVER_TIMEOUT - do */
struct nldlm_set_recover_timeout_req {
	struct {
		__u32 recover_timeout:1;
	} _present;

	__u32 recover_timeout;
};

static inline struct nldlm_set_recover_timeout_req *
nldlm_set_recover_timeout_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_recover_timeout_req));
}
void
nldlm_set_recover_timeout_req_free(struct nldlm_set_recover_timeout_req *req);

static inline void
nldlm_set_recover_timeout_req_set_recover_timeout(struct nldlm_set_recover_timeout_req *req,
						  __u32 recover_timeout)
{
	req->_present.recover_timeout = 1;
	req->recover_timeout = recover_timeout;
}

/*
 * The DLM recovery has some wait events that requires other nodes
to answer in a time. This is the timeout value how long DLM
should wait until giving up in the DLM recovery routines.

 */
int nldlm_set_recover_timeout(struct ynl_sock *ys,
			      struct nldlm_set_recover_timeout_req *req);

/* ============== NLDLM_CMD_SET_INACTIVE_TIMEOUT ============== */
/* NLDLM_CMD_SET_INACTIVE_TIMEOUT - do */
struct nldlm_set_inactive_timeout_req {
	struct {
		__u32 inactive_timeout:1;
	} _present;

	__u32 inactive_timeout;
};

static inline struct nldlm_set_inactive_timeout_req *
nldlm_set_inactive_timeout_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_inactive_timeout_req));
}
void
nldlm_set_inactive_timeout_req_free(struct nldlm_set_inactive_timeout_req *req);

static inline void
nldlm_set_inactive_timeout_req_set_inactive_timeout(struct nldlm_set_inactive_timeout_req *req,
						    __u32 inactive_timeout)
{
	req->_present.inactive_timeout = 1;
	req->inactive_timeout = inactive_timeout;
}

/*
 * DLM lock resources are keeping in memory if not being used inside
the lockspace anymore to fast reactivate them if they get used after
a certain timeout that can be specified here.

 */
int nldlm_set_inactive_timeout(struct ynl_sock *ys,
			       struct nldlm_set_inactive_timeout_req *req);

/* ============== NLDLM_CMD_SET_LOG_LEVEL ============== */
/* NLDLM_CMD_SET_LOG_LEVEL - do */
struct nldlm_set_log_level_req {
	struct {
		__u32 log_level:1;
	} _present;

	__u32 log_level;
};

static inline struct nldlm_set_log_level_req *
nldlm_set_log_level_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_log_level_req));
}
void nldlm_set_log_level_req_free(struct nldlm_set_log_level_req *req);

static inline void
nldlm_set_log_level_req_set_log_level(struct nldlm_set_log_level_req *req,
				      __u32 log_level)
{
	req->_present.log_level = 1;
	req->log_level = log_level;
}

/*
 * set the DLM kernel logging level.

 */
int nldlm_set_log_level(struct ynl_sock *ys,
			struct nldlm_set_log_level_req *req);

/* ============== NLDLM_CMD_SET_DEFAULT_MARK ============== */
/* NLDLM_CMD_SET_DEFAULT_MARK - do */
struct nldlm_set_default_mark_req {
	struct {
		__u32 default_mark:1;
	} _present;

	__u32 default_mark;
};

static inline struct nldlm_set_default_mark_req *
nldlm_set_default_mark_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_default_mark_req));
}
void nldlm_set_default_mark_req_free(struct nldlm_set_default_mark_req *req);

static inline void
nldlm_set_default_mark_req_set_default_mark(struct nldlm_set_default_mark_req *req,
					    __u32 default_mark)
{
	req->_present.default_mark = 1;
	req->default_mark = default_mark;
}

/*
 * set the default skb mark value for DLM sockets.

 */
int nldlm_set_default_mark(struct ynl_sock *ys,
			   struct nldlm_set_default_mark_req *req);

/* ============== NLDLM_CMD_SET_RECOVER_CALLBACKS ============== */
/* NLDLM_CMD_SET_RECOVER_CALLBACKS - do */
struct nldlm_set_recover_callbacks_req {
	struct {
		__u32 recover_callbacks:1;
	} _present;
};

static inline struct nldlm_set_recover_callbacks_req *
nldlm_set_recover_callbacks_req_alloc(void)
{
	return calloc(1, sizeof(struct nldlm_set_recover_callbacks_req));
}
void
nldlm_set_recover_callbacks_req_free(struct nldlm_set_recover_callbacks_req *req);

static inline void
nldlm_set_recover_callbacks_req_set_recover_callbacks(struct nldlm_set_recover_callbacks_req *req)
{
	req->_present.recover_callbacks = 1;
}

/*
 * set feature for recover callbacks that is required for some kernel
DLM users.

 */
int nldlm_set_recover_callbacks(struct ynl_sock *ys,
				struct nldlm_set_recover_callbacks_req *req);

#endif /* _LINUX_NLDLM_GEN_H */
